fn main() {
    let mut primes = vec![];

    for n in 2..=2_000_000 {
        let prime_check_max = (n as f64).sqrt().ceil() as usize;
        let mut is_prime = true;
        for prime in primes.clone() {
            if n % prime == 0 {
                is_prime = false;
                break;
            } else if prime > prime_check_max {
                break;
            }
        }
        if is_prime {
            primes.push(n);
        }
    }

    println!("{}", primes.iter().sum::<usize>());
}