fn main() {
    let mut n = 1;
    loop {
        let triangular_num = triangular(n);
        let divisors = get_divisors(triangular_num);
        if divisors.len() > 500 {
            println!("{triangular_num}");
            break;
        }
        n +=1;
    }
}

fn triangular(nth: usize) -> usize {
    (1..=nth).sum::<usize>()
}

fn get_divisors(n: usize) -> Vec<usize> {
    let mut divisors = vec![1];
    let mut potential_divisor = 2;
    while (potential_divisor * potential_divisor) < n {
        if n % potential_divisor == 0 {
            divisors.push(potential_divisor);
            divisors.push(n / potential_divisor);
        }
        potential_divisor = potential_divisor + 1;
    }
    divisors
}
