use project_euler::number::Number;

fn main() {
    let power = get_power(1000);
    println!("{}", power.digits.iter().sum::<isize>())
}

fn get_power(exp: usize) -> Number {
    let mut number = Number::from(1);
    if exp == 0 {
        return number;
    }
    for _n in 1..=exp {
        number = number * 2;
    }
    number
}

