use project_euler::number::Number;

fn main() {
    let mut num_letters = 0;
    for n in 1..=1000 {
        num_letters += number_to_words(Number::from(n)).len();
    }
    println!("{num_letters}");
}


fn number_to_words(n: Number) -> String {
    let mut number_string = String::new();
    let digits = n.clone().digits;
    for (pos, &digit) in digits.iter().enumerate() {
        if digits.len() > 1 && digits.len() - 2 == pos {
            if digit == 1 {
                if digits[digits.len()-1] == 0 {
                    number_string.push_str("ten");
                }
                if digits[digits.len()-1] == 1 {
                    number_string.push_str("eleven");
                }
                if digits[digits.len()-1] == 2 {
                    number_string.push_str("twelve");
                }
                if digits[digits.len()-1] == 3 {
                    number_string.push_str("thirteen");
                }
                if digits[digits.len()-1] == 4 {
                    number_string.push_str("fourteen");
                }
                if digits[digits.len()-1] == 5 {
                    number_string.push_str("fifteen");
                }
                if digits[digits.len()-1] == 6 {
                    number_string.push_str("sixteen");
                }
                if digits[digits.len()-1] == 7 {
                    number_string.push_str("seventeen");
                }
                if digits[digits.len()-1] == 8 {
                    number_string.push_str("eighteen");
                }
                if digits[digits.len()-1] == 9 {
                    number_string.push_str("nineteen");
                }
            }
            if digit == 2 {
                number_string.push_str("twenty");
            }
            if digit == 3 {
                number_string.push_str("thirty");
            }
            if digit == 4 {
                number_string.push_str("forty");
            }
            if digit == 5 {
                number_string.push_str("fifty");
            }
            if digit == 6 {
                number_string.push_str("sixty");
            }
            if digit == 7 {
                number_string.push_str("seventy");
            }
            if digit == 8 {
                number_string.push_str("eighty");
            }
            if digit == 9 {
                number_string.push_str("ninety");
            }
        } else if digits.len() == 1 || (digits.len() - 2 != pos && !(digits.len() - 1 == pos && digits[digits.len() - 2] == 1)) {
            if digit == 1 {
                number_string.push_str("one");
            }
            if digit == 2 {
                number_string.push_str("two");
            }
            if digit == 3 {
                number_string.push_str("three");
            }
            if digit == 4 {
                number_string.push_str("four");
            }
            if digit == 5 {
                number_string.push_str("five");
            }
            if digit == 6 {
                number_string.push_str("six");
            }
            if digit == 7 {
                number_string.push_str("seven");
            }
            if digit == 8 {
                number_string.push_str("eight");
            }
            if digit == 9 {
                number_string.push_str("nine");
            }
        }
        if digits.len() > 2 && pos == digits.len() - 3 && digit != 0 {
            number_string.push_str("hundred");
            if !(digits[pos + 1] == 0 && digits[pos + 2] == 0) {
                number_string.push_str("and");
            }
        }
        if digits.len() > 3 && pos == digits.len() - 4 && digit != 0 {
            number_string.push_str("thousand");
        }
    }
    println!("{n}: {number_string}");
    number_string
}