use std::collections::HashSet;
use project_euler::number::Number;

fn main() {
    let mut terms: HashSet<Number> = HashSet::new();
    let max = 100;
    for a in 2..=max {
        for b in 2..=max {
            let a_num = Number::from(a);
            terms.insert(a_num.pow(b as u32));
        }
    }
    println!("{}", terms.len());
}