use project_euler::number::Number;

fn main() {
    println!("{}", power_series(1000));
}

fn power_series(length: usize) -> Number {
    let mut number = Number::from(0);
    for i in 1..=length {
        number = number + Number::from(i as isize).pow(i as u32);
    }
    number
}
