use project_euler::number::Number;

fn main() {
    let factorial = get_factorial(100);
     dbg!(factorial.digits.iter().sum::<isize>());
}

fn get_factorial(factorial: isize) -> Number {
    let mut number = Number::from(1);
    if factorial == 0 {
        return number;
    }
    for n in 1..=factorial {
        number = number * n;
    }
    number
}